(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.juexiaoStatSdk = {}));
}(this, (function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    function createCommonjsModule(fn, module) {
    	return module = { exports: {} }, fn(module, module.exports), module.exports;
    }

    var md5 = createCommonjsModule(function (module) {
    /**
     * [js-md5]{@link https://github.com/emn178/js-md5}
     *
     * @namespace md5
     * @version 0.7.3
     * @author Chen, Yi-Cyuan [emn178@gmail.com]
     * @copyright Chen, Yi-Cyuan 2014-2017
     * @license MIT
     */
    (function () {

      var ERROR = 'input is invalid type';
      var WINDOW = typeof window === 'object';
      var root = WINDOW ? window : {};
      if (root.JS_MD5_NO_WINDOW) {
        WINDOW = false;
      }
      var WEB_WORKER = !WINDOW && typeof self === 'object';
      var NODE_JS = !root.JS_MD5_NO_NODE_JS && typeof process === 'object' && process.versions && process.versions.node;
      if (NODE_JS) {
        root = commonjsGlobal;
      } else if (WEB_WORKER) {
        root = self;
      }
      var COMMON_JS = !root.JS_MD5_NO_COMMON_JS && 'object' === 'object' && module.exports;
      var ARRAY_BUFFER = !root.JS_MD5_NO_ARRAY_BUFFER && typeof ArrayBuffer !== 'undefined';
      var HEX_CHARS = '0123456789abcdef'.split('');
      var EXTRA = [128, 32768, 8388608, -2147483648];
      var SHIFT = [0, 8, 16, 24];
      var OUTPUT_TYPES = ['hex', 'array', 'digest', 'buffer', 'arrayBuffer', 'base64'];
      var BASE64_ENCODE_CHAR = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split('');

      var blocks = [], buffer8;
      if (ARRAY_BUFFER) {
        var buffer = new ArrayBuffer(68);
        buffer8 = new Uint8Array(buffer);
        blocks = new Uint32Array(buffer);
      }

      if (root.JS_MD5_NO_NODE_JS || !Array.isArray) {
        Array.isArray = function (obj) {
          return Object.prototype.toString.call(obj) === '[object Array]';
        };
      }

      if (ARRAY_BUFFER && (root.JS_MD5_NO_ARRAY_BUFFER_IS_VIEW || !ArrayBuffer.isView)) {
        ArrayBuffer.isView = function (obj) {
          return typeof obj === 'object' && obj.buffer && obj.buffer.constructor === ArrayBuffer;
        };
      }

      /**
       * @method hex
       * @memberof md5
       * @description Output hash as hex string
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {String} Hex string
       * @example
       * md5.hex('The quick brown fox jumps over the lazy dog');
       * // equal to
       * md5('The quick brown fox jumps over the lazy dog');
       */
      /**
       * @method digest
       * @memberof md5
       * @description Output hash as bytes array
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {Array} Bytes array
       * @example
       * md5.digest('The quick brown fox jumps over the lazy dog');
       */
      /**
       * @method array
       * @memberof md5
       * @description Output hash as bytes array
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {Array} Bytes array
       * @example
       * md5.array('The quick brown fox jumps over the lazy dog');
       */
      /**
       * @method arrayBuffer
       * @memberof md5
       * @description Output hash as ArrayBuffer
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {ArrayBuffer} ArrayBuffer
       * @example
       * md5.arrayBuffer('The quick brown fox jumps over the lazy dog');
       */
      /**
       * @method buffer
       * @deprecated This maybe confuse with Buffer in node.js. Please use arrayBuffer instead.
       * @memberof md5
       * @description Output hash as ArrayBuffer
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {ArrayBuffer} ArrayBuffer
       * @example
       * md5.buffer('The quick brown fox jumps over the lazy dog');
       */
      /**
       * @method base64
       * @memberof md5
       * @description Output hash as base64 string
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {String} base64 string
       * @example
       * md5.base64('The quick brown fox jumps over the lazy dog');
       */
      var createOutputMethod = function (outputType) {
        return function (message) {
          return new Md5(true).update(message)[outputType]();
        };
      };

      /**
       * @method create
       * @memberof md5
       * @description Create Md5 object
       * @returns {Md5} Md5 object.
       * @example
       * var hash = md5.create();
       */
      /**
       * @method update
       * @memberof md5
       * @description Create and update Md5 object
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {Md5} Md5 object.
       * @example
       * var hash = md5.update('The quick brown fox jumps over the lazy dog');
       * // equal to
       * var hash = md5.create();
       * hash.update('The quick brown fox jumps over the lazy dog');
       */
      var createMethod = function () {
        var method = createOutputMethod('hex');
        if (NODE_JS) {
          method = nodeWrap(method);
        }
        method.create = function () {
          return new Md5();
        };
        method.update = function (message) {
          return method.create().update(message);
        };
        for (var i = 0; i < OUTPUT_TYPES.length; ++i) {
          var type = OUTPUT_TYPES[i];
          method[type] = createOutputMethod(type);
        }
        return method;
      };

      var nodeWrap = function (method) {
        var crypto = eval("require('crypto')");
        var Buffer = eval("require('buffer').Buffer");
        var nodeMethod = function (message) {
          if (typeof message === 'string') {
            return crypto.createHash('md5').update(message, 'utf8').digest('hex');
          } else {
            if (message === null || message === undefined) {
              throw ERROR;
            } else if (message.constructor === ArrayBuffer) {
              message = new Uint8Array(message);
            }
          }
          if (Array.isArray(message) || ArrayBuffer.isView(message) ||
            message.constructor === Buffer) {
            return crypto.createHash('md5').update(new Buffer(message)).digest('hex');
          } else {
            return method(message);
          }
        };
        return nodeMethod;
      };

      /**
       * Md5 class
       * @class Md5
       * @description This is internal class.
       * @see {@link md5.create}
       */
      function Md5(sharedMemory) {
        if (sharedMemory) {
          blocks[0] = blocks[16] = blocks[1] = blocks[2] = blocks[3] =
          blocks[4] = blocks[5] = blocks[6] = blocks[7] =
          blocks[8] = blocks[9] = blocks[10] = blocks[11] =
          blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
          this.blocks = blocks;
          this.buffer8 = buffer8;
        } else {
          if (ARRAY_BUFFER) {
            var buffer = new ArrayBuffer(68);
            this.buffer8 = new Uint8Array(buffer);
            this.blocks = new Uint32Array(buffer);
          } else {
            this.blocks = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
          }
        }
        this.h0 = this.h1 = this.h2 = this.h3 = this.start = this.bytes = this.hBytes = 0;
        this.finalized = this.hashed = false;
        this.first = true;
      }

      /**
       * @method update
       * @memberof Md5
       * @instance
       * @description Update hash
       * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
       * @returns {Md5} Md5 object.
       * @see {@link md5.update}
       */
      Md5.prototype.update = function (message) {
        if (this.finalized) {
          return;
        }

        var notString, type = typeof message;
        if (type !== 'string') {
          if (type === 'object') {
            if (message === null) {
              throw ERROR;
            } else if (ARRAY_BUFFER && message.constructor === ArrayBuffer) {
              message = new Uint8Array(message);
            } else if (!Array.isArray(message)) {
              if (!ARRAY_BUFFER || !ArrayBuffer.isView(message)) {
                throw ERROR;
              }
            }
          } else {
            throw ERROR;
          }
          notString = true;
        }
        var code, index = 0, i, length = message.length, blocks = this.blocks;
        var buffer8 = this.buffer8;

        while (index < length) {
          if (this.hashed) {
            this.hashed = false;
            blocks[0] = blocks[16];
            blocks[16] = blocks[1] = blocks[2] = blocks[3] =
            blocks[4] = blocks[5] = blocks[6] = blocks[7] =
            blocks[8] = blocks[9] = blocks[10] = blocks[11] =
            blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
          }

          if (notString) {
            if (ARRAY_BUFFER) {
              for (i = this.start; index < length && i < 64; ++index) {
                buffer8[i++] = message[index];
              }
            } else {
              for (i = this.start; index < length && i < 64; ++index) {
                blocks[i >> 2] |= message[index] << SHIFT[i++ & 3];
              }
            }
          } else {
            if (ARRAY_BUFFER) {
              for (i = this.start; index < length && i < 64; ++index) {
                code = message.charCodeAt(index);
                if (code < 0x80) {
                  buffer8[i++] = code;
                } else if (code < 0x800) {
                  buffer8[i++] = 0xc0 | (code >> 6);
                  buffer8[i++] = 0x80 | (code & 0x3f);
                } else if (code < 0xd800 || code >= 0xe000) {
                  buffer8[i++] = 0xe0 | (code >> 12);
                  buffer8[i++] = 0x80 | ((code >> 6) & 0x3f);
                  buffer8[i++] = 0x80 | (code & 0x3f);
                } else {
                  code = 0x10000 + (((code & 0x3ff) << 10) | (message.charCodeAt(++index) & 0x3ff));
                  buffer8[i++] = 0xf0 | (code >> 18);
                  buffer8[i++] = 0x80 | ((code >> 12) & 0x3f);
                  buffer8[i++] = 0x80 | ((code >> 6) & 0x3f);
                  buffer8[i++] = 0x80 | (code & 0x3f);
                }
              }
            } else {
              for (i = this.start; index < length && i < 64; ++index) {
                code = message.charCodeAt(index);
                if (code < 0x80) {
                  blocks[i >> 2] |= code << SHIFT[i++ & 3];
                } else if (code < 0x800) {
                  blocks[i >> 2] |= (0xc0 | (code >> 6)) << SHIFT[i++ & 3];
                  blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
                } else if (code < 0xd800 || code >= 0xe000) {
                  blocks[i >> 2] |= (0xe0 | (code >> 12)) << SHIFT[i++ & 3];
                  blocks[i >> 2] |= (0x80 | ((code >> 6) & 0x3f)) << SHIFT[i++ & 3];
                  blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
                } else {
                  code = 0x10000 + (((code & 0x3ff) << 10) | (message.charCodeAt(++index) & 0x3ff));
                  blocks[i >> 2] |= (0xf0 | (code >> 18)) << SHIFT[i++ & 3];
                  blocks[i >> 2] |= (0x80 | ((code >> 12) & 0x3f)) << SHIFT[i++ & 3];
                  blocks[i >> 2] |= (0x80 | ((code >> 6) & 0x3f)) << SHIFT[i++ & 3];
                  blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
                }
              }
            }
          }
          this.lastByteIndex = i;
          this.bytes += i - this.start;
          if (i >= 64) {
            this.start = i - 64;
            this.hash();
            this.hashed = true;
          } else {
            this.start = i;
          }
        }
        if (this.bytes > 4294967295) {
          this.hBytes += this.bytes / 4294967296 << 0;
          this.bytes = this.bytes % 4294967296;
        }
        return this;
      };

      Md5.prototype.finalize = function () {
        if (this.finalized) {
          return;
        }
        this.finalized = true;
        var blocks = this.blocks, i = this.lastByteIndex;
        blocks[i >> 2] |= EXTRA[i & 3];
        if (i >= 56) {
          if (!this.hashed) {
            this.hash();
          }
          blocks[0] = blocks[16];
          blocks[16] = blocks[1] = blocks[2] = blocks[3] =
          blocks[4] = blocks[5] = blocks[6] = blocks[7] =
          blocks[8] = blocks[9] = blocks[10] = blocks[11] =
          blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
        }
        blocks[14] = this.bytes << 3;
        blocks[15] = this.hBytes << 3 | this.bytes >>> 29;
        this.hash();
      };

      Md5.prototype.hash = function () {
        var a, b, c, d, bc, da, blocks = this.blocks;

        if (this.first) {
          a = blocks[0] - 680876937;
          a = (a << 7 | a >>> 25) - 271733879 << 0;
          d = (-1732584194 ^ a & 2004318071) + blocks[1] - 117830708;
          d = (d << 12 | d >>> 20) + a << 0;
          c = (-271733879 ^ (d & (a ^ -271733879))) + blocks[2] - 1126478375;
          c = (c << 17 | c >>> 15) + d << 0;
          b = (a ^ (c & (d ^ a))) + blocks[3] - 1316259209;
          b = (b << 22 | b >>> 10) + c << 0;
        } else {
          a = this.h0;
          b = this.h1;
          c = this.h2;
          d = this.h3;
          a += (d ^ (b & (c ^ d))) + blocks[0] - 680876936;
          a = (a << 7 | a >>> 25) + b << 0;
          d += (c ^ (a & (b ^ c))) + blocks[1] - 389564586;
          d = (d << 12 | d >>> 20) + a << 0;
          c += (b ^ (d & (a ^ b))) + blocks[2] + 606105819;
          c = (c << 17 | c >>> 15) + d << 0;
          b += (a ^ (c & (d ^ a))) + blocks[3] - 1044525330;
          b = (b << 22 | b >>> 10) + c << 0;
        }

        a += (d ^ (b & (c ^ d))) + blocks[4] - 176418897;
        a = (a << 7 | a >>> 25) + b << 0;
        d += (c ^ (a & (b ^ c))) + blocks[5] + 1200080426;
        d = (d << 12 | d >>> 20) + a << 0;
        c += (b ^ (d & (a ^ b))) + blocks[6] - 1473231341;
        c = (c << 17 | c >>> 15) + d << 0;
        b += (a ^ (c & (d ^ a))) + blocks[7] - 45705983;
        b = (b << 22 | b >>> 10) + c << 0;
        a += (d ^ (b & (c ^ d))) + blocks[8] + 1770035416;
        a = (a << 7 | a >>> 25) + b << 0;
        d += (c ^ (a & (b ^ c))) + blocks[9] - 1958414417;
        d = (d << 12 | d >>> 20) + a << 0;
        c += (b ^ (d & (a ^ b))) + blocks[10] - 42063;
        c = (c << 17 | c >>> 15) + d << 0;
        b += (a ^ (c & (d ^ a))) + blocks[11] - 1990404162;
        b = (b << 22 | b >>> 10) + c << 0;
        a += (d ^ (b & (c ^ d))) + blocks[12] + 1804603682;
        a = (a << 7 | a >>> 25) + b << 0;
        d += (c ^ (a & (b ^ c))) + blocks[13] - 40341101;
        d = (d << 12 | d >>> 20) + a << 0;
        c += (b ^ (d & (a ^ b))) + blocks[14] - 1502002290;
        c = (c << 17 | c >>> 15) + d << 0;
        b += (a ^ (c & (d ^ a))) + blocks[15] + 1236535329;
        b = (b << 22 | b >>> 10) + c << 0;
        a += (c ^ (d & (b ^ c))) + blocks[1] - 165796510;
        a = (a << 5 | a >>> 27) + b << 0;
        d += (b ^ (c & (a ^ b))) + blocks[6] - 1069501632;
        d = (d << 9 | d >>> 23) + a << 0;
        c += (a ^ (b & (d ^ a))) + blocks[11] + 643717713;
        c = (c << 14 | c >>> 18) + d << 0;
        b += (d ^ (a & (c ^ d))) + blocks[0] - 373897302;
        b = (b << 20 | b >>> 12) + c << 0;
        a += (c ^ (d & (b ^ c))) + blocks[5] - 701558691;
        a = (a << 5 | a >>> 27) + b << 0;
        d += (b ^ (c & (a ^ b))) + blocks[10] + 38016083;
        d = (d << 9 | d >>> 23) + a << 0;
        c += (a ^ (b & (d ^ a))) + blocks[15] - 660478335;
        c = (c << 14 | c >>> 18) + d << 0;
        b += (d ^ (a & (c ^ d))) + blocks[4] - 405537848;
        b = (b << 20 | b >>> 12) + c << 0;
        a += (c ^ (d & (b ^ c))) + blocks[9] + 568446438;
        a = (a << 5 | a >>> 27) + b << 0;
        d += (b ^ (c & (a ^ b))) + blocks[14] - 1019803690;
        d = (d << 9 | d >>> 23) + a << 0;
        c += (a ^ (b & (d ^ a))) + blocks[3] - 187363961;
        c = (c << 14 | c >>> 18) + d << 0;
        b += (d ^ (a & (c ^ d))) + blocks[8] + 1163531501;
        b = (b << 20 | b >>> 12) + c << 0;
        a += (c ^ (d & (b ^ c))) + blocks[13] - 1444681467;
        a = (a << 5 | a >>> 27) + b << 0;
        d += (b ^ (c & (a ^ b))) + blocks[2] - 51403784;
        d = (d << 9 | d >>> 23) + a << 0;
        c += (a ^ (b & (d ^ a))) + blocks[7] + 1735328473;
        c = (c << 14 | c >>> 18) + d << 0;
        b += (d ^ (a & (c ^ d))) + blocks[12] - 1926607734;
        b = (b << 20 | b >>> 12) + c << 0;
        bc = b ^ c;
        a += (bc ^ d) + blocks[5] - 378558;
        a = (a << 4 | a >>> 28) + b << 0;
        d += (bc ^ a) + blocks[8] - 2022574463;
        d = (d << 11 | d >>> 21) + a << 0;
        da = d ^ a;
        c += (da ^ b) + blocks[11] + 1839030562;
        c = (c << 16 | c >>> 16) + d << 0;
        b += (da ^ c) + blocks[14] - 35309556;
        b = (b << 23 | b >>> 9) + c << 0;
        bc = b ^ c;
        a += (bc ^ d) + blocks[1] - 1530992060;
        a = (a << 4 | a >>> 28) + b << 0;
        d += (bc ^ a) + blocks[4] + 1272893353;
        d = (d << 11 | d >>> 21) + a << 0;
        da = d ^ a;
        c += (da ^ b) + blocks[7] - 155497632;
        c = (c << 16 | c >>> 16) + d << 0;
        b += (da ^ c) + blocks[10] - 1094730640;
        b = (b << 23 | b >>> 9) + c << 0;
        bc = b ^ c;
        a += (bc ^ d) + blocks[13] + 681279174;
        a = (a << 4 | a >>> 28) + b << 0;
        d += (bc ^ a) + blocks[0] - 358537222;
        d = (d << 11 | d >>> 21) + a << 0;
        da = d ^ a;
        c += (da ^ b) + blocks[3] - 722521979;
        c = (c << 16 | c >>> 16) + d << 0;
        b += (da ^ c) + blocks[6] + 76029189;
        b = (b << 23 | b >>> 9) + c << 0;
        bc = b ^ c;
        a += (bc ^ d) + blocks[9] - 640364487;
        a = (a << 4 | a >>> 28) + b << 0;
        d += (bc ^ a) + blocks[12] - 421815835;
        d = (d << 11 | d >>> 21) + a << 0;
        da = d ^ a;
        c += (da ^ b) + blocks[15] + 530742520;
        c = (c << 16 | c >>> 16) + d << 0;
        b += (da ^ c) + blocks[2] - 995338651;
        b = (b << 23 | b >>> 9) + c << 0;
        a += (c ^ (b | ~d)) + blocks[0] - 198630844;
        a = (a << 6 | a >>> 26) + b << 0;
        d += (b ^ (a | ~c)) + blocks[7] + 1126891415;
        d = (d << 10 | d >>> 22) + a << 0;
        c += (a ^ (d | ~b)) + blocks[14] - 1416354905;
        c = (c << 15 | c >>> 17) + d << 0;
        b += (d ^ (c | ~a)) + blocks[5] - 57434055;
        b = (b << 21 | b >>> 11) + c << 0;
        a += (c ^ (b | ~d)) + blocks[12] + 1700485571;
        a = (a << 6 | a >>> 26) + b << 0;
        d += (b ^ (a | ~c)) + blocks[3] - 1894986606;
        d = (d << 10 | d >>> 22) + a << 0;
        c += (a ^ (d | ~b)) + blocks[10] - 1051523;
        c = (c << 15 | c >>> 17) + d << 0;
        b += (d ^ (c | ~a)) + blocks[1] - 2054922799;
        b = (b << 21 | b >>> 11) + c << 0;
        a += (c ^ (b | ~d)) + blocks[8] + 1873313359;
        a = (a << 6 | a >>> 26) + b << 0;
        d += (b ^ (a | ~c)) + blocks[15] - 30611744;
        d = (d << 10 | d >>> 22) + a << 0;
        c += (a ^ (d | ~b)) + blocks[6] - 1560198380;
        c = (c << 15 | c >>> 17) + d << 0;
        b += (d ^ (c | ~a)) + blocks[13] + 1309151649;
        b = (b << 21 | b >>> 11) + c << 0;
        a += (c ^ (b | ~d)) + blocks[4] - 145523070;
        a = (a << 6 | a >>> 26) + b << 0;
        d += (b ^ (a | ~c)) + blocks[11] - 1120210379;
        d = (d << 10 | d >>> 22) + a << 0;
        c += (a ^ (d | ~b)) + blocks[2] + 718787259;
        c = (c << 15 | c >>> 17) + d << 0;
        b += (d ^ (c | ~a)) + blocks[9] - 343485551;
        b = (b << 21 | b >>> 11) + c << 0;

        if (this.first) {
          this.h0 = a + 1732584193 << 0;
          this.h1 = b - 271733879 << 0;
          this.h2 = c - 1732584194 << 0;
          this.h3 = d + 271733878 << 0;
          this.first = false;
        } else {
          this.h0 = this.h0 + a << 0;
          this.h1 = this.h1 + b << 0;
          this.h2 = this.h2 + c << 0;
          this.h3 = this.h3 + d << 0;
        }
      };

      /**
       * @method hex
       * @memberof Md5
       * @instance
       * @description Output hash as hex string
       * @returns {String} Hex string
       * @see {@link md5.hex}
       * @example
       * hash.hex();
       */
      Md5.prototype.hex = function () {
        this.finalize();

        var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3;

        return HEX_CHARS[(h0 >> 4) & 0x0F] + HEX_CHARS[h0 & 0x0F] +
          HEX_CHARS[(h0 >> 12) & 0x0F] + HEX_CHARS[(h0 >> 8) & 0x0F] +
          HEX_CHARS[(h0 >> 20) & 0x0F] + HEX_CHARS[(h0 >> 16) & 0x0F] +
          HEX_CHARS[(h0 >> 28) & 0x0F] + HEX_CHARS[(h0 >> 24) & 0x0F] +
          HEX_CHARS[(h1 >> 4) & 0x0F] + HEX_CHARS[h1 & 0x0F] +
          HEX_CHARS[(h1 >> 12) & 0x0F] + HEX_CHARS[(h1 >> 8) & 0x0F] +
          HEX_CHARS[(h1 >> 20) & 0x0F] + HEX_CHARS[(h1 >> 16) & 0x0F] +
          HEX_CHARS[(h1 >> 28) & 0x0F] + HEX_CHARS[(h1 >> 24) & 0x0F] +
          HEX_CHARS[(h2 >> 4) & 0x0F] + HEX_CHARS[h2 & 0x0F] +
          HEX_CHARS[(h2 >> 12) & 0x0F] + HEX_CHARS[(h2 >> 8) & 0x0F] +
          HEX_CHARS[(h2 >> 20) & 0x0F] + HEX_CHARS[(h2 >> 16) & 0x0F] +
          HEX_CHARS[(h2 >> 28) & 0x0F] + HEX_CHARS[(h2 >> 24) & 0x0F] +
          HEX_CHARS[(h3 >> 4) & 0x0F] + HEX_CHARS[h3 & 0x0F] +
          HEX_CHARS[(h3 >> 12) & 0x0F] + HEX_CHARS[(h3 >> 8) & 0x0F] +
          HEX_CHARS[(h3 >> 20) & 0x0F] + HEX_CHARS[(h3 >> 16) & 0x0F] +
          HEX_CHARS[(h3 >> 28) & 0x0F] + HEX_CHARS[(h3 >> 24) & 0x0F];
      };

      /**
       * @method toString
       * @memberof Md5
       * @instance
       * @description Output hash as hex string
       * @returns {String} Hex string
       * @see {@link md5.hex}
       * @example
       * hash.toString();
       */
      Md5.prototype.toString = Md5.prototype.hex;

      /**
       * @method digest
       * @memberof Md5
       * @instance
       * @description Output hash as bytes array
       * @returns {Array} Bytes array
       * @see {@link md5.digest}
       * @example
       * hash.digest();
       */
      Md5.prototype.digest = function () {
        this.finalize();

        var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3;
        return [
          h0 & 0xFF, (h0 >> 8) & 0xFF, (h0 >> 16) & 0xFF, (h0 >> 24) & 0xFF,
          h1 & 0xFF, (h1 >> 8) & 0xFF, (h1 >> 16) & 0xFF, (h1 >> 24) & 0xFF,
          h2 & 0xFF, (h2 >> 8) & 0xFF, (h2 >> 16) & 0xFF, (h2 >> 24) & 0xFF,
          h3 & 0xFF, (h3 >> 8) & 0xFF, (h3 >> 16) & 0xFF, (h3 >> 24) & 0xFF
        ];
      };

      /**
       * @method array
       * @memberof Md5
       * @instance
       * @description Output hash as bytes array
       * @returns {Array} Bytes array
       * @see {@link md5.array}
       * @example
       * hash.array();
       */
      Md5.prototype.array = Md5.prototype.digest;

      /**
       * @method arrayBuffer
       * @memberof Md5
       * @instance
       * @description Output hash as ArrayBuffer
       * @returns {ArrayBuffer} ArrayBuffer
       * @see {@link md5.arrayBuffer}
       * @example
       * hash.arrayBuffer();
       */
      Md5.prototype.arrayBuffer = function () {
        this.finalize();

        var buffer = new ArrayBuffer(16);
        var blocks = new Uint32Array(buffer);
        blocks[0] = this.h0;
        blocks[1] = this.h1;
        blocks[2] = this.h2;
        blocks[3] = this.h3;
        return buffer;
      };

      /**
       * @method buffer
       * @deprecated This maybe confuse with Buffer in node.js. Please use arrayBuffer instead.
       * @memberof Md5
       * @instance
       * @description Output hash as ArrayBuffer
       * @returns {ArrayBuffer} ArrayBuffer
       * @see {@link md5.buffer}
       * @example
       * hash.buffer();
       */
      Md5.prototype.buffer = Md5.prototype.arrayBuffer;

      /**
       * @method base64
       * @memberof Md5
       * @instance
       * @description Output hash as base64 string
       * @returns {String} base64 string
       * @see {@link md5.base64}
       * @example
       * hash.base64();
       */
      Md5.prototype.base64 = function () {
        var v1, v2, v3, base64Str = '', bytes = this.array();
        for (var i = 0; i < 15;) {
          v1 = bytes[i++];
          v2 = bytes[i++];
          v3 = bytes[i++];
          base64Str += BASE64_ENCODE_CHAR[v1 >>> 2] +
            BASE64_ENCODE_CHAR[(v1 << 4 | v2 >>> 4) & 63] +
            BASE64_ENCODE_CHAR[(v2 << 2 | v3 >>> 6) & 63] +
            BASE64_ENCODE_CHAR[v3 & 63];
        }
        v1 = bytes[i];
        base64Str += BASE64_ENCODE_CHAR[v1 >>> 2] +
          BASE64_ENCODE_CHAR[(v1 << 4) & 63] +
          '==';
        return base64Str;
      };

      var exports = createMethod();

      if (COMMON_JS) {
        module.exports = exports;
      } else {
        /**
         * @method md5
         * @description Md5 hash function, export to global in browsers.
         * @param {String|Array|Uint8Array|ArrayBuffer} message message to hash
         * @returns {String} md5 hashes
         * @example
         * md5(''); // d41d8cd98f00b204e9800998ecf8427e
         * md5('The quick brown fox jumps over the lazy dog'); // 9e107d9d372bb6826bd81d3542a419d6
         * md5('The quick brown fox jumps over the lazy dog.'); // e4d909c290d0fb1ca068ffaddf22cbd0
         *
         * // It also supports UTF-8 encoding
         * md5('中文'); // a7bac2239fcdcb3a067903d8077c4a07
         *
         * // It also supports byte `Array`, `Uint8Array`, `ArrayBuffer`
         * md5([]); // d41d8cd98f00b204e9800998ecf8427e
         * md5(new Uint8Array([])); // d41d8cd98f00b204e9800998ecf8427e
         */
        root.md5 = exports;
      }
    })();
    });

    var Constants;
    (function (Constants) {
        Constants["FETCH_URL"] = "https://sdk.juexiaotime.com/sdk_js";
        Constants["FETCH_IMAGE_URL"] = "https://sdk.juexiaotime.com/sdk_js.gif";
        Constants["JUEXIAO_STAT_UUID"] = "JUEXIAO_STAT_UUID";
        Constants["LIBRARY_JS"] = "js";
        // LIBRARY_MINI = 'wechat'
    })(Constants || (Constants = {}));
    var version = '1.4.3';

    /**
     * 生成UUID
     *
     * @export
     * @param {LibrayType} [sdkType='js']
     * @returns {string}
     */
    function generateUUID(sdkType) {
        if (sdkType === void 0) { sdkType = 'js'; }
        var d = new Date().getTime();
        var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c === 'x' ? r : (r & 0x3) | 0x8).toString(16);
        });
        return sdkType + "_" + uuid;
    }
    /**
     * 校验数据格式是否正确
     *
     * @export
     * @param {object} data
     * @returns {boolean} 是否通过校验
     */
    function checkPropertyKey(data) {
        var reg = /^([a-zA-Z][a-zA-Z_0-9]{0,49}$)/;
        var isPass = true;
        Object.keys(data).forEach(function (key) {
            if (!reg.test(key)) {
                isPass = false;
                throw new Error("\u6570\u636E\u683C\u5F0F\u6821\u9A8C\u5931\u8D25\uFF0C\u5C5E\u6027 " + key + " \u4E0D\u7B26\u5408\u89C4\u5219\uFF1A\u4EE5\u5B57\u6BCD\u5F00\u5934\uFF0C\u53EF\u5305\u542B\u5B57\u6BCD\u3001\u6570\u503C\u3001\u4E0B\u5212\u7EBF\uFF0C\u4E14\u957F\u5EA6\u4E0D\u8D85\u8FC750");
            }
        });
        return isPass;
    }
    /**
     * 版本号比较
     *
     * @param {string} curV 当前版本号
     * @param {string} reqV 比较版本号
     * @returns curV > reqV
     */
    var compareVersion = function (curV, reqV) {
        if (curV && reqV) {
            var arr1 = curV.split('.');
            var arr2 = reqV.split('.');
            var minLength = Math.min(arr1.length, arr2.length);
            var position = 0;
            var diff = 0;
            while (position < minLength && diff === 0) {
                position++;
                diff = parseInt(arr1[position]) - parseInt(arr2[position]);
            }
            diff = diff !== 0 ? diff : arr1.length - arr2.length;
            return diff > 0;
        }
        else {
            console.warn('版本号不能为空');
            return false;
        }
    };

    /**
     * 格式化操作系统
     *
     * @export
     * @param {*} system
     * @returns
     */
    function formatSystem(system) {
        var _system = system.toLowerCase();
        if (_system === 'ios') {
            return 'IOS';
        }
        else if (_system === 'android') {
            return 'Android';
        }
        else {
            return system;
        }
    }
    /**
     * 发送数据
     *
     * @export
     * @param {string} id
     * @param {string} url
     * @param {UserEvent} data
     */
    function sendData(id, url, data, debug) {
        if (debug === void 0) { debug = false; }
        if (checkPropertyKey(data.properties)) {
            var URL_1 = url + "?data=" + encodeURIComponent(JSON.stringify(data)) + "&project_id=" + id + "&type=" + Constants.LIBRARY_JS;
            // 开启调试时传入
            if (debug) {
                URL_1 += '&debug=true';
            }
            // 根据环境不同使用 wx,my,qq
            if (wx) {
                wx.request({
                    url: URL_1,
                    method: 'GET'
                });
            }
        }
    }

    // 定义一些常量
    var x_PI = (3.14159265358979324 * 3000.0) / 180.0;
    var PI = 3.1415926535897932384626;
    var a = 6378245.0;
    var ee = 0.00669342162296594323;
    /**
     * 火星坐标系 (GCJ-02) 与百度坐标系 (BD-09) 的转换
     * 即谷歌、高德 转 百度
     * @param lng
     * @param lat
     * @returns {*[]}
     */
    function gcj02tobd09(lng, lat) {
        var z = Math.sqrt(lng * lng + lat * lat) + 0.00002 * Math.sin(lat * x_PI);
        var theta = Math.atan2(lat, lng) + 0.000003 * Math.cos(lng * x_PI);
        var bd_lng = z * Math.cos(theta) + 0.0065;
        var bd_lat = z * Math.sin(theta) + 0.006;
        return [bd_lng, bd_lat];
    }
    /**
     * WGS84转GCj02
     * @param lng
     * @param lat
     * @returns {*[]}
     */
    function wgs84togcj02(lng, lat) {
        if (out_of_china(lng, lat)) {
            return [lng, lat];
        }
        else {
            var dlat = transformlat(lng - 105.0, lat - 35.0);
            var dlng = transformlng(lng - 105.0, lat - 35.0);
            var radlat = (lat / 180.0) * PI;
            var magic = Math.sin(radlat);
            magic = 1 - ee * magic * magic;
            var sqrtmagic = Math.sqrt(magic);
            dlat = (dlat * 180.0) / (((a * (1 - ee)) / (magic * sqrtmagic)) * PI);
            dlng = (dlng * 180.0) / ((a / sqrtmagic) * Math.cos(radlat) * PI);
            var mglat = lat + dlat;
            var mglng = lng + dlng;
            return [mglng, mglat];
        }
    }
    function transformlat(lng, lat) {
        var ret = -100.0 +
            2.0 * lng +
            3.0 * lat +
            0.2 * lat * lat +
            0.1 * lng * lat +
            0.2 * Math.sqrt(Math.abs(lng));
        ret += ((20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0) / 3.0;
        ret += ((20.0 * Math.sin(lat * PI) + 40.0 * Math.sin((lat / 3.0) * PI)) * 2.0) / 3.0;
        ret += ((160.0 * Math.sin((lat / 12.0) * PI) + 320 * Math.sin((lat * PI) / 30.0)) * 2.0) / 3.0;
        return ret;
    }
    function transformlng(lng, lat) {
        var ret = 300.0 + lng + 2.0 * lat + 0.1 * lng * lng + 0.1 * lng * lat + 0.1 * Math.sqrt(Math.abs(lng));
        ret += ((20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0) / 3.0;
        ret += ((20.0 * Math.sin(lng * PI) + 40.0 * Math.sin((lng / 3.0) * PI)) * 2.0) / 3.0;
        ret += ((150.0 * Math.sin((lng / 12.0) * PI) + 300.0 * Math.sin((lng / 30.0) * PI)) * 2.0) / 3.0;
        return ret;
    }
    /**
     * 判断是否在国内，不在国内则不做偏移
     * @param lng
     * @param lat
     * @returns {boolean}
     */
    function out_of_china(lng, lat) {
        return lng < 72.004 || lng > 137.8347 || lat < 0.8293 || lat > 55.8271 || false;
    }
    /**
     * wgs84坐标转百度-09坐标
     *
     * @export
     * @param {*} lng
     * @param {*} lat
     * @returns
     */
    function wgs84tobd09(lng, lat) {
        var cj = wgs84togcj02(lng, lat);
        var bd = gcj02tobd09(cj[0], cj[1]);
        return {
            longitude: bd[0],
            latitude: bd[1]
        };
    }

    var JueXiaoMiniStatSDK = /** @class */ (function () {
        /**
         * Creates an instance of JueXiaoMiniStatSDK.
         * @param {InitOption} options
         * @memberof JueXiaoMiniStatSDK
         */
        function JueXiaoMiniStatSDK(options) {
            this.sdkVersion = version;
            this.sdkType = Constants.LIBRARY_JS;
            /** 项目唯一标识 */
            this.projectId = '';
            this.isDebug = false;
            this.trackTimes = 1;
            this.trackData = {};
            this.initProperties = {};
            this.projectId = options.id;
            this.source = options.source;
            this.isDebug = typeof options.debug === 'boolean' ? options.debug : false;
            this.init(options);
        }
        JueXiaoMiniStatSDK.prototype.init = function (options) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, locationInfo;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            this.trackData.distinct_id = this.initUserId();
                            this.trackData.is_login = false;
                            // 保证应用在初始调用时有预置属性（此时没有经纬度）
                            _a = this;
                            return [4 /*yield*/, this.registerPresetProperties(options.appSource)];
                        case 1:
                            // 保证应用在初始调用时有预置属性（此时没有经纬度）
                            _a.initProperties = _b.sent();
                            this.trackData.properties = this.initProperties;
                            console.info('PRESET_PROPERTIES', this.initProperties);
                            if (options.userId) {
                                this.login(options.userId);
                            }
                            // 兼容版本 version > 1.3.13
                            if (compareVersion(this.sdkVersion, '1.3.13')) {
                                // 自动触发启动事件
                                this.track('$startApp');
                            }
                            return [4 /*yield*/, this.initPosition()];
                        case 2:
                            locationInfo = _b.sent();
                            this.initProperties.jx_longitude = locationInfo.longitude;
                            this.initProperties.jx_latitude = locationInfo.latitude;
                            // 如果获取位置成功 上报一次jx_location
                            locationInfo.latitude && this.track('jx_location');
                            return [2 /*return*/];
                    }
                });
            });
        };
        JueXiaoMiniStatSDK.prototype.initPosition = function () {
            return __awaiter(this, void 0, void 0, function () {
                var info, bdInfo;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, wx.getLocation({ type: 'wgs84' })];
                        case 1:
                            info = _a.sent();
                            bdInfo = wgs84tobd09(info.longitude, info.latitude);
                            return [2 /*return*/, {
                                    longitude: bdInfo.longitude,
                                    latitude: bdInfo.latitude
                                }];
                        case 2:
                            _a.sent();
                            return [2 /*return*/, {
                                    longitude: undefined,
                                    latitude: undefined
                                }];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * 初始化UUID
         *
         * @private
         * @returns {string}
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.initUserId = function () {
            var uuid = wx.getStorageSync(Constants.JUEXIAO_STAT_UUID);
            if (!uuid) {
                uuid = generateUUID(Constants.LIBRARY_JS);
                wx.setStorageSync(Constants.JUEXIAO_STAT_UUID, uuid);
            }
            return uuid;
        };
        JueXiaoMiniStatSDK.prototype._trackEvent = function (trackType, data) {
            var _this = this;
            if (trackType === void 0) { trackType = 'track'; }
            var trackAction = function () {
                _this.trackData.type = trackType;
                _this.trackData.time = new Date().getTime();
                if (trackType !== 'track') {
                    delete _this.trackData['event'];
                }
                _this.trackData.properties = Object.assign({}, _this.initProperties, data || {});
                if (trackType === 'track') {
                    _this.trackData.properties.jx_track_id = _this.trackTimes;
                    _this.trackTimes += 1;
                }
                sendData(_this.projectId, Constants.FETCH_IMAGE_URL, _this.trackData, _this.isDebug);
            };
            trackAction();
        };
        JueXiaoMiniStatSDK.prototype.track = function (eventName, data) {
            if (data === void 0) { data = {}; }
            this.trackData.event = eventName;
            this._trackEvent('track', data);
        };
        /**
         * 设置预置属性 已存在的字段则覆盖，不存在则自动创建
         *
         * @param {*} [options={}]
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.profileSet = function (options) {
            if (options === void 0) { options = {}; }
            this.track('$startApp');
            this._trackEvent('profileSet', options);
        };
        /**
         * 设置用户首次属性，与 profileSet 不同的是，如果被设置的用户属性已存在，则这条记录会被忽略，如果属性不存在则会自动创建
         *
         * @param {object} options
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.profileSetOnce = function (options) {
            if (options === void 0) { options = {}; }
            this._trackEvent('profileSetOnce', options);
        };
        /**
         * 获取session_id
         *
         * @private
         * @returns {string}
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoMiniStatSDK.prototype.getSessionId = function () {
            return md5(this.trackData.distinct_id) + "_" + new Date().getTime();
        };
        /**
         * 注册预置属性
         *
         * @private
         * @param {Object} params
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.registerPresetProperties = function (appSource) {
            return __awaiter(this, void 0, void 0, function () {
                var preset, _a, sys;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            preset = {};
                            preset.app_source = appSource;
                            preset.jx_lib = this.sdkType;
                            preset.jx_lib_version = this.sdkVersion;
                            preset.jx_js_source = this.source;
                            preset.session_id = this.getSessionId();
                            _a = preset;
                            return [4 /*yield*/, wx.getNetworkType()];
                        case 1:
                            _a.jx_network_type = (_b.sent()).networkType;
                            sys = wx.getSystemInfoSync();
                            preset.jx_manufacturer = sys['brand'];
                            preset.jx_device_mode = sys['model'];
                            preset.jx_screen_width = Number(sys['screenWidth']);
                            preset.jx_screen_height = Number(sys['screenHeight']);
                            preset.jx_os = formatSystem(sys['platform']);
                            preset.jx_os_version =
                                sys['system'].indexOf(' ') > -1 ? sys['system'].split(' ')[1] : sys['system'];
                            console.info("sdk-version: " + this.sdkVersion);
                            return [2 /*return*/, preset];
                    }
                });
            });
        };
        /**
         * 用户注册-用于绑定登录id和匿名id之间的操作
         *
         * @param {string} loginId 用户注册成功后返回的userid
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.trackSignUp = function (loginId) {
            if (!loginId) {
                throw new Error('please make sure the login id is correct!');
            }
            this.trackData.properties.anonymous_id = this.initUserId();
            this.trackData.properties.register_id = loginId;
            this._trackEvent('trackSignUp');
            delete this.trackData.properties['anonymous_id'];
            delete this.trackData.properties['register_id'];
        };
        /**
         * 用户登录 - 用于更新用户id
         *
         * @param {string}
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.login = function (loginId) {
            if (loginId) {
                this.trackData.is_login = true;
                this.trackData.user_id = String(loginId);
            }
            else {
                throw new Error('please make sure the login id is correct!');
            }
        };
        /**
         * 退出登录
         *
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.logout = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.trackData.is_login = false;
                    this.trackData.user_id = '';
                    this.trackData.properties = this.initProperties;
                    return [2 /*return*/];
                });
            });
        };
        /**
         * 设置公共属性，设置后每次上报都会带有设置的属性
         *
         * @param {*} [params={}]
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoMiniStatSDK.prototype.setPublicProperties = function (params) {
            if (params === void 0) { params = {}; }
            this.initProperties = Object.assign({}, params, this.initProperties);
        };
        /**
         * 上传opendid
         *
         * 为了提高数据的准确性，小程序需要在运行时从服务端获取 openid 和 unionid
         *
         * 注意：openid一定能获取到，unionid在用户从未登录授权过公众号时无法获取到
         * @param {string} openid
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.setOpenid = function (openid) {
            // 传入openid 且 当前没有登录时才设置openid
            // 已登录用户无需再设置 openid
            if (openid && !this.trackData.is_login) {
                this.trackData.distinct_id = String(openid);
                // 把本地的uuid替换为openid
                wx.setStorageSync(Constants.JUEXIAO_STAT_UUID, openid);
            }
        };
        /**
         * 上传unionid
         *
         * 为了提高数据的准确性，小程序需要在运行时从服务端获取 openid 和 unionid
         *
         * 注意：openid一定能获取到，unionid在用户从未登录授权过公众号时无法获取到
         * @param {string} unionid
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoMiniStatSDK.prototype.setUnionid = function (unionid) {
            if (unionid) {
                this.initProperties.unionid = unionid;
            }
        };
        return JueXiaoMiniStatSDK;
    }());

    /**
     * 获取操作系统 和 浏览器 信息
     *
     * @export
     * @returns os 操作系统名字 ver 操作系统版本号
     */
    function getOsInfo() {
        var ua = window.navigator.userAgent.toLowerCase();
        var isAndroid = ua.match(/android/gi);
        var isIos = ua.match(/iphone|ipod|ipad/gi);
        var isWindows = ua.match(/windows/gi);
        var isMac = ua.match(/macintosh|mac os x/i);
        var isMobile = isAndroid || isIos;
        var os = '';
        var osVersion = '';
        if (isAndroid) {
            os = 'Android';
            var index = ua.indexOf('android');
            osVersion = String(parseFloat(ua.slice(index + 8)));
        }
        else if (isIos) {
            os = 'IOS';
            var info = ua.match(/cpu iphone os (.*?) like mac os/) || [];
            osVersion = String(info.length && info[1].replace(/_/g, '.'));
        }
        else if (isMac) {
            os = 'Mac';
            var info = ua.split('mac os x ')[1].split(' ')[0];
            osVersion = info
                .substr(0, 8)
                .replace(')', '')
                .replace(/_/g, '.');
        }
        else if (isWindows) {
            os = 'Windows';
            var index = ua.indexOf('windows');
            osVersion = String(parseFloat(ua.slice(index + 11)));
        }
        else {
            os = 'unknow';
            osVersion = 'unknow';
        }
        // PC需要返回浏览器信息
        var browser = '';
        var browserVersion = '';
        if (!isMobile) {
            var info_1 = {
                IE: /tablet|msie/.test(ua) && !/opera/.test(ua),
                Opera: /opera/.test(ua),
                Safari: /version.*safari/.test(ua),
                Chrome: /chrome/.test(ua),
                Firefox: /gecko/.test(ua) && !/webkit/.test(ua) // 匹配Firefox浏览器
            };
            var browserInfo = Object.keys(info_1).filter(function (browser) { return info_1[browser]; });
            if (browserInfo.length) {
                browser = browserInfo[0];
                if (browser === 'IE') {
                    if (ua.indexOf('msie') > -1) {
                        var index = ua.indexOf('msie');
                        browserVersion = String(parseFloat(ua.substring(index + 5, ua.indexOf(';', index))));
                    }
                    else {
                        var index = ua.indexOf('rv:');
                        browserVersion = String(parseFloat(ua.substring(index + 3)));
                    }
                }
                else {
                    var index = ua.indexOf(browser.toLowerCase() + "/");
                    console.info(ua, index);
                    browserVersion = String(parseFloat(ua.slice(index + browser.length + 1))) || '';
                }
            }
            else {
                browser = 'unknow';
                browserVersion = 'unknow';
            }
        }
        var obj = {
            isMobile: isMobile,
            os: os,
            osVersion: osVersion,
            browser: browser,
            browserVersion: browserVersion
        };
        return obj;
    }
    /**
     * 使用图片的请求方式
     *
     * @export
     * @param {string} id
     * @param {string} url
     * @param {UserEvent} data
     */
    function sendDataWithImg(id, url, data, debug) {
        if (debug === void 0) { debug = false; }
        if (checkPropertyKey(data.properties)) {
            var img_1 = new Image();
            img_1.crossOrigin = 'anonymous';
            var key_1 = 'img_log_' + Math.floor(Math.random() * 2147483648).toString(36); // 为本次数据请求创建一个唯一id
            window[key_1] = img_1;
            img_1.onload = img_1.onerror = img_1.onabort = function () {
                img_1.onload = img_1.onerror = img_1.onabort = null; // 清除img元素
                window[key_1] = null;
                img_1 = null;
            };
            var fetchUrl = url + "?data=" + encodeURIComponent(JSON.stringify(data)) + "&project_id=" + id + "&type=" + Constants.LIBRARY_JS;
            // 开启调试时传入
            if (debug) {
                fetchUrl += '&debug=true';
            }
            img_1.src = fetchUrl;
        }
    }
    /**
     * 获取经纬度
     *
     * @export
     * @returns {Promise<PositionInfo>}
     */
    function getLocation() {
        return new Promise(function (resolve) {
            var options = {
                enableHighAccuracy: true,
                maximumAge: 0
            };
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(function (position) {
                    var bdInfo = wgs84tobd09(position.coords.longitude, position.coords.latitude);
                    resolve({
                        longitude: bdInfo.longitude,
                        latitude: bdInfo.latitude
                    });
                }, function (error) {
                    console.warn(error.message);
                    resolve({
                        longitude: undefined,
                        latitude: undefined
                    });
                }, options);
            }
            else {
                resolve({
                    longitude: undefined,
                    latitude: undefined
                });
            }
        });
    }

    var JueXiaoBrowserStatSDK = /** @class */ (function () {
        /**
         * Creates an instance of JueXiaoBrowserStatSDK.
         * @param {InitOption} options
         * @memberof JueXiaoBrowserStatSDK
         */
        function JueXiaoBrowserStatSDK(options) {
            this.sdkVersion = version;
            this.sdkType = Constants.LIBRARY_JS;
            /** 项目唯一标识 */
            this.projectId = '';
            this.isDebug = false;
            this.trackTimes = 1;
            this.trackData = {};
            this.initProperties = {};
            this.projectId = options.id;
            this.source = options.source;
            this.isDebug = typeof options.debug === 'boolean' ? options.debug : false;
            this.init(options);
        }
        JueXiaoBrowserStatSDK.prototype.init = function (options) {
            return __awaiter(this, void 0, void 0, function () {
                var locationInfo;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.trackData.distinct_id = this.initUserId();
                            this.trackData.is_login = false;
                            this.initProperties = this.registerPresetProperties(options.appSource);
                            this.trackData.properties = this.initProperties;
                            if (options.userId) {
                                this.login(options.userId);
                            }
                            this.initActiveTimeout();
                            // 兼容版本 version > 1.3.13
                            if (compareVersion(this.sdkVersion, '1.3.13')) {
                                // 自动触发启动事件
                                this.track('$startApp');
                            }
                            return [4 /*yield*/, getLocation()];
                        case 1:
                            locationInfo = _a.sent();
                            this.initProperties.jx_longitude = locationInfo.longitude;
                            this.initProperties.jx_latitude = locationInfo.latitude;
                            // 如果获取位置成功 上报一次jx_location
                            locationInfo.latitude && this.track('jx_location');
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * 初始化活跃状态定时器
         * 当用户初始化sdk后，一直挂起到第二天，会被认为是非活跃状态，需要主动 track 一次 $startApp 事件
         * @private
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.initActiveTimeout = function () {
            var _this = this;
            var now = new Date();
            var year = now.getFullYear();
            var month = now.getMonth() + 1;
            var day = now.getDate();
            // ios 日期不能使用"-" 使用"/"代替
            var date = year + "/" + month + "/" + day;
            var startTime = now.getTime();
            // 结束时间为第二天的0点过1秒
            var endTime = new Date(date).getTime() + 24 * 60 * 60 * 1000 + 1000;
            setTimeout(function () {
                _this.track('$startApp');
                _this.initActiveTimeout();
            }, endTime - startTime);
        };
        /**
         * 初始化UUID
         *
         * @private
         * @returns {string}
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.initUserId = function () {
            var uuid = window.localStorage.getItem(Constants.JUEXIAO_STAT_UUID);
            if (!uuid) {
                uuid = generateUUID();
                window.localStorage.setItem(Constants.JUEXIAO_STAT_UUID, uuid);
            }
            return uuid;
        };
        JueXiaoBrowserStatSDK.prototype._trackEvent = function (trackType, data) {
            if (trackType === void 0) { trackType = 'track'; }
            this.trackData.type = trackType;
            this.trackData.time = new Date().getTime();
            if (trackType !== 'track') {
                delete this.trackData['event'];
            }
            this.trackData.properties = Object.assign({}, this.initProperties, data || {});
            if (trackType === 'track') {
                this.trackData.properties.jx_track_id = this.trackTimes;
                this.trackTimes += 1;
            }
            sendDataWithImg(this.projectId, Constants.FETCH_IMAGE_URL, this.trackData, this.isDebug);
        };
        JueXiaoBrowserStatSDK.prototype.track = function (eventName, data) {
            if (data === void 0) { data = {}; }
            this.trackData.event = eventName;
            this._trackEvent('track', data);
        };
        /**
         * 设置预置属性 已存在的字段则覆盖，不存在则自动创建
         *
         * @param {*} [options={}]
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.profileSet = function (options) {
            if (options === void 0) { options = {}; }
            // const data = Object.assign({}, this.trackData.properties, options)
            this._trackEvent('profileSet', options);
            this.track('$startApp');
        };
        /**
         * 设置用户首次属性，与 profileSet 不同的是，如果被设置的用户属性已存在，则这条记录会被忽略，如果属性不存在则会自动创建
         *
         * @param {object} options
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.profileSetOnce = function (options) {
            if (options === void 0) { options = {}; }
            // const data = Object.assign({}, options, this.trackData.properties)
            this._trackEvent('profileSetOnce', options);
        };
        /**
         * 获取session_id
         *
         * @private
         * @returns {string}
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.getSessionId = function () {
            return md5(this.trackData.distinct_id) + "_" + new Date().getTime();
        };
        /**
         * 注册预置属性
         *
         * @private
         * @param {Object} params
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.registerPresetProperties = function (appSource) {
            var preset = {};
            var osInfo = getOsInfo();
            preset.app_source = appSource;
            preset.session_id = this.getSessionId();
            preset.jx_lib = this.sdkType;
            preset.jx_js_source = this.source;
            preset.jx_lib_version = this.sdkVersion;
            if (navigator['connection']) {
                preset.jx_network_type = navigator['connection'].effectiveType;
            }
            else {
                preset.jx_network_type = 'unknown';
            }
            preset.jx_screen_height = window.innerHeight;
            preset.jx_screen_width = window.innerWidth;
            preset.jx_os = osInfo.os;
            preset.jx_os_version = osInfo.osVersion;
            if (!osInfo.isMobile) {
                preset.jx_browser = osInfo.browser;
                preset.jx_browser_version = osInfo.browserVersion;
            }
            console.info("sdk-version: " + this.sdkVersion);
            return preset;
        };
        /**
         * 用户注册-用于绑定登录id和匿名id之间的操作
         *
         * @param {string}
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.trackSignUp = function (loginId) {
            if (!loginId) {
                throw new Error('please make sure the login id is correct!');
            }
            this.trackData.properties.anonymous_id = this.initUserId();
            this.trackData.properties.register_id = loginId;
            this._trackEvent('trackSignUp');
            delete this.trackData.properties['anonymous_id'];
            delete this.trackData.properties['register_id'];
        };
        /**
         * 用户登录 - 用于更新用户id
         *
         * @param {string}
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.login = function (loginId) {
            if (loginId) {
                this.trackData.is_login = true;
                this.trackData.user_id = String(loginId);
            }
            else {
                throw new Error('please make sure the login id is correct!');
            }
        };
        /**
         * 退出登录
         *
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.logout = function () {
            this.trackData.is_login = false;
            this.trackData.user_id = '';
            this.trackData.properties = this.initProperties;
        };
        /**
         * 设置公共属性，设置后每次上报都会带有设置的属性
         *
         * @param {*} [params={}]
         * @memberof JueXiaoBrowserStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.setPublicProperties = function (params) {
            if (params === void 0) { params = {}; }
            this.initProperties = Object.assign({}, params, this.initProperties);
        };
        /**
         * 上传unionid
         *
         * 为了提高数据的准确性，小程序需要在运行时从服务端获取 openid 和 unionid
         *
         * 注意：openid一定能获取到，unionid在用户从未登录授权过公众号时无法获取到
         * @param {string} unionid
         * @memberof JueXiaoMiniStatSDK
         */
        JueXiaoBrowserStatSDK.prototype.setUnionid = function (unionid) {
            if (unionid) {
                this.initProperties.unionid = unionid;
            }
        };
        return JueXiaoBrowserStatSDK;
    }());

    exports.BrowserStatSDK = JueXiaoBrowserStatSDK;
    exports.MiniStatSDK = JueXiaoMiniStatSDK;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=juexiao-stat-sdk.umd.js.map
