"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var js_md5_1 = __importDefault(require("js-md5"));
var types_1 = require("../types");
var browser_1 = require("../utils/browser");
var utils_1 = require("../utils");
var JueXiaoBrowserStatSDK = /** @class */ (function () {
    /**
     * Creates an instance of JueXiaoBrowserStatSDK.
     * @param {InitOption} options
     * @memberof JueXiaoBrowserStatSDK
     */
    function JueXiaoBrowserStatSDK(options) {
        this.sdkVersion = types_1.version;
        this.sdkType = types_1.Constants.LIBRARY_JS;
        /** 项目唯一标识 */
        this.projectId = '';
        this.isDebug = false;
        this.trackTimes = 1;
        this.trackData = {};
        this.initProperties = {};
        this.projectId = options.id;
        this.source = options.source;
        this.isDebug = typeof options.debug === 'boolean' ? options.debug : false;
        this.init(options);
    }
    JueXiaoBrowserStatSDK.prototype.init = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var locationInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.trackData.distinct_id = this.initUserId();
                        this.trackData.is_login = false;
                        this.initProperties = this.registerPresetProperties(options.appSource);
                        this.trackData.properties = this.initProperties;
                        if (options.userId) {
                            this.login(options.userId);
                        }
                        this.initActiveTimeout();
                        // 兼容版本 version > 1.3.13
                        if (utils_1.compareVersion(this.sdkVersion, '1.3.13')) {
                            // 自动触发启动事件
                            this.track('$startApp');
                        }
                        return [4 /*yield*/, browser_1.getLocation()];
                    case 1:
                        locationInfo = _a.sent();
                        this.initProperties.jx_longitude = locationInfo.longitude;
                        this.initProperties.jx_latitude = locationInfo.latitude;
                        // 如果获取位置成功 上报一次jx_location
                        locationInfo.latitude && this.track('jx_location');
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 初始化活跃状态定时器
     * 当用户初始化sdk后，一直挂起到第二天，会被认为是非活跃状态，需要主动 track 一次 $startApp 事件
     * @private
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.initActiveTimeout = function () {
        var _this = this;
        var now = new Date();
        var year = now.getFullYear();
        var month = now.getMonth() + 1;
        var day = now.getDate();
        // ios 日期不能使用"-" 使用"/"代替
        var date = year + "/" + month + "/" + day;
        var startTime = now.getTime();
        // 结束时间为第二天的0点过1秒
        var endTime = new Date(date).getTime() + 24 * 60 * 60 * 1000 + 1000;
        setTimeout(function () {
            _this.track('$startApp');
            _this.initActiveTimeout();
        }, endTime - startTime);
    };
    /**
     * 初始化UUID
     *
     * @private
     * @returns {string}
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.initUserId = function () {
        var uuid = window.localStorage.getItem(types_1.Constants.JUEXIAO_STAT_UUID);
        if (!uuid) {
            uuid = utils_1.generateUUID();
            window.localStorage.setItem(types_1.Constants.JUEXIAO_STAT_UUID, uuid);
        }
        return uuid;
    };
    JueXiaoBrowserStatSDK.prototype._trackEvent = function (trackType, data) {
        if (trackType === void 0) { trackType = 'track'; }
        this.trackData.type = trackType;
        this.trackData.time = new Date().getTime();
        if (trackType !== 'track') {
            delete this.trackData['event'];
        }
        this.trackData.properties = Object.assign({}, this.initProperties, data || {});
        if (trackType === 'track') {
            this.trackData.properties.jx_track_id = this.trackTimes;
            this.trackTimes += 1;
        }
        browser_1.sendDataWithImg(this.projectId, types_1.Constants.FETCH_IMAGE_URL, this.trackData, this.isDebug);
    };
    JueXiaoBrowserStatSDK.prototype.track = function (eventName, data) {
        if (data === void 0) { data = {}; }
        this.trackData.event = eventName;
        this._trackEvent('track', data);
    };
    /**
     * 设置预置属性 已存在的字段则覆盖，不存在则自动创建
     *
     * @param {*} [options={}]
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.profileSet = function (options) {
        if (options === void 0) { options = {}; }
        // const data = Object.assign({}, this.trackData.properties, options)
        this._trackEvent('profileSet', options);
        this.track('$startApp');
    };
    /**
     * 设置用户首次属性，与 profileSet 不同的是，如果被设置的用户属性已存在，则这条记录会被忽略，如果属性不存在则会自动创建
     *
     * @param {object} options
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.profileSetOnce = function (options) {
        if (options === void 0) { options = {}; }
        // const data = Object.assign({}, options, this.trackData.properties)
        this._trackEvent('profileSetOnce', options);
    };
    /**
     * 获取session_id
     *
     * @private
     * @returns {string}
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.getSessionId = function () {
        return js_md5_1.default(this.trackData.distinct_id) + "_" + new Date().getTime();
    };
    /**
     * 注册预置属性
     *
     * @private
     * @param {Object} params
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.registerPresetProperties = function (appSource) {
        var preset = {};
        var osInfo = browser_1.getOsInfo();
        preset.app_source = appSource;
        preset.session_id = this.getSessionId();
        preset.jx_lib = this.sdkType;
        preset.jx_js_source = this.source;
        preset.jx_lib_version = this.sdkVersion;
        if (navigator['connection']) {
            preset.jx_network_type = navigator['connection'].effectiveType;
        }
        else {
            preset.jx_network_type = 'unknown';
        }
        preset.jx_screen_height = window.innerHeight;
        preset.jx_screen_width = window.innerWidth;
        preset.jx_os = osInfo.os;
        preset.jx_os_version = osInfo.osVersion;
        if (!osInfo.isMobile) {
            preset.jx_browser = osInfo.browser;
            preset.jx_browser_version = osInfo.browserVersion;
        }
        console.info("sdk-version: " + this.sdkVersion);
        return preset;
    };
    /**
     * 用户注册-用于绑定登录id和匿名id之间的操作
     *
     * @param {string}
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.trackSignUp = function (loginId) {
        if (!loginId) {
            throw new Error('please make sure the login id is correct!');
        }
        this.trackData.properties.anonymous_id = this.initUserId();
        this.trackData.properties.register_id = loginId;
        this._trackEvent('trackSignUp');
        delete this.trackData.properties['anonymous_id'];
        delete this.trackData.properties['register_id'];
    };
    /**
     * 用户登录 - 用于更新用户id
     *
     * @param {string}
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.login = function (loginId) {
        if (loginId) {
            this.trackData.is_login = true;
            this.trackData.user_id = String(loginId);
        }
        else {
            throw new Error('please make sure the login id is correct!');
        }
    };
    /**
     * 退出登录
     *
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.logout = function () {
        this.trackData.is_login = false;
        this.trackData.user_id = '';
        this.trackData.properties = this.initProperties;
    };
    /**
     * 设置公共属性，设置后每次上报都会带有设置的属性
     *
     * @param {*} [params={}]
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.setPublicProperties = function (params) {
        if (params === void 0) { params = {}; }
        this.initProperties = Object.assign({}, params, this.initProperties);
    };
    /**
     * 上传unionid
     *
     * 为了提高数据的准确性，小程序需要在运行时从服务端获取 openid 和 unionid
     *
     * 注意：openid一定能获取到，unionid在用户从未登录授权过公众号时无法获取到
     * @param {string} unionid
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoBrowserStatSDK.prototype.setUnionid = function (unionid) {
        if (unionid) {
            this.initProperties.unionid = unionid;
        }
    };
    return JueXiaoBrowserStatSDK;
}());
exports.default = JueXiaoBrowserStatSDK;
//# sourceMappingURL=browser.js.map