"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var js_md5_1 = __importDefault(require("js-md5"));
var types_1 = require("../types");
var mini_1 = require("../utils/mini");
var utils_1 = require("../utils");
var location_1 = require("../utils/location");
var JueXiaoMiniStatSDK = /** @class */ (function () {
    /**
     * Creates an instance of JueXiaoMiniStatSDK.
     * @param {InitOption} options
     * @memberof JueXiaoMiniStatSDK
     */
    function JueXiaoMiniStatSDK(options) {
        this.sdkVersion = types_1.version;
        this.sdkType = types_1.Constants.LIBRARY_JS;
        /** 项目唯一标识 */
        this.projectId = '';
        this.isDebug = false;
        this.trackTimes = 1;
        this.trackData = {};
        this.initProperties = {};
        this.projectId = options.id;
        this.source = options.source;
        this.isDebug = typeof options.debug === 'boolean' ? options.debug : false;
        this.init(options);
    }
    JueXiaoMiniStatSDK.prototype.init = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, locationInfo;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.trackData.distinct_id = this.initUserId();
                        this.trackData.is_login = false;
                        // 保证应用在初始调用时有预置属性（此时没有经纬度）
                        _a = this;
                        return [4 /*yield*/, this.registerPresetProperties(options.appSource)];
                    case 1:
                        // 保证应用在初始调用时有预置属性（此时没有经纬度）
                        _a.initProperties = _b.sent();
                        this.trackData.properties = this.initProperties;
                        console.info('PRESET_PROPERTIES', this.initProperties);
                        if (options.userId) {
                            this.login(options.userId);
                        }
                        // 兼容版本 version > 1.3.13
                        if (utils_1.compareVersion(this.sdkVersion, '1.3.13')) {
                            // 自动触发启动事件
                            this.track('$startApp');
                        }
                        return [4 /*yield*/, this.initPosition()];
                    case 2:
                        locationInfo = _b.sent();
                        this.initProperties.jx_longitude = locationInfo.longitude;
                        this.initProperties.jx_latitude = locationInfo.latitude;
                        // 如果获取位置成功 上报一次jx_location
                        locationInfo.latitude && this.track('jx_location');
                        return [2 /*return*/];
                }
            });
        });
    };
    JueXiaoMiniStatSDK.prototype.initPosition = function () {
        return __awaiter(this, void 0, void 0, function () {
            var info, bdInfo, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, wx.getLocation({ type: 'wgs84' })];
                    case 1:
                        info = _a.sent();
                        bdInfo = location_1.wgs84tobd09(info.longitude, info.latitude);
                        return [2 /*return*/, {
                                longitude: bdInfo.longitude,
                                latitude: bdInfo.latitude
                            }];
                    case 2:
                        error_1 = _a.sent();
                        return [2 /*return*/, {
                                longitude: undefined,
                                latitude: undefined
                            }];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 初始化UUID
     *
     * @private
     * @returns {string}
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.initUserId = function () {
        var uuid = wx.getStorageSync(types_1.Constants.JUEXIAO_STAT_UUID);
        if (!uuid) {
            uuid = utils_1.generateUUID(types_1.Constants.LIBRARY_JS);
            wx.setStorageSync(types_1.Constants.JUEXIAO_STAT_UUID, uuid);
        }
        return uuid;
    };
    JueXiaoMiniStatSDK.prototype._trackEvent = function (trackType, data) {
        var _this = this;
        if (trackType === void 0) { trackType = 'track'; }
        var trackAction = function () {
            _this.trackData.type = trackType;
            _this.trackData.time = new Date().getTime();
            if (trackType !== 'track') {
                delete _this.trackData['event'];
            }
            _this.trackData.properties = Object.assign({}, _this.initProperties, data || {});
            if (trackType === 'track') {
                _this.trackData.properties.jx_track_id = _this.trackTimes;
                _this.trackTimes += 1;
            }
            mini_1.sendData(_this.projectId, types_1.Constants.FETCH_IMAGE_URL, _this.trackData, _this.isDebug);
        };
        trackAction();
    };
    JueXiaoMiniStatSDK.prototype.track = function (eventName, data) {
        if (data === void 0) { data = {}; }
        this.trackData.event = eventName;
        this._trackEvent('track', data);
    };
    /**
     * 设置预置属性 已存在的字段则覆盖，不存在则自动创建
     *
     * @param {*} [options={}]
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.profileSet = function (options) {
        if (options === void 0) { options = {}; }
        this.track('$startApp');
        this._trackEvent('profileSet', options);
    };
    /**
     * 设置用户首次属性，与 profileSet 不同的是，如果被设置的用户属性已存在，则这条记录会被忽略，如果属性不存在则会自动创建
     *
     * @param {object} options
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.profileSetOnce = function (options) {
        if (options === void 0) { options = {}; }
        this._trackEvent('profileSetOnce', options);
    };
    /**
     * 获取session_id
     *
     * @private
     * @returns {string}
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoMiniStatSDK.prototype.getSessionId = function () {
        return js_md5_1.default(this.trackData.distinct_id) + "_" + new Date().getTime();
    };
    /**
     * 注册预置属性
     *
     * @private
     * @param {Object} params
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.registerPresetProperties = function (appSource) {
        return __awaiter(this, void 0, void 0, function () {
            var preset, _a, sys;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        preset = {};
                        preset.app_source = appSource;
                        preset.jx_lib = this.sdkType;
                        preset.jx_lib_version = this.sdkVersion;
                        preset.jx_js_source = this.source;
                        preset.session_id = this.getSessionId();
                        _a = preset;
                        return [4 /*yield*/, wx.getNetworkType()];
                    case 1:
                        _a.jx_network_type = (_b.sent()).networkType;
                        sys = wx.getSystemInfoSync();
                        preset.jx_manufacturer = sys['brand'];
                        preset.jx_device_mode = sys['model'];
                        preset.jx_screen_width = Number(sys['screenWidth']);
                        preset.jx_screen_height = Number(sys['screenHeight']);
                        preset.jx_os = mini_1.formatSystem(sys['platform']);
                        preset.jx_os_version =
                            sys['system'].indexOf(' ') > -1 ? sys['system'].split(' ')[1] : sys['system'];
                        console.info("sdk-version: " + this.sdkVersion);
                        return [2 /*return*/, preset];
                }
            });
        });
    };
    /**
     * 用户注册-用于绑定登录id和匿名id之间的操作
     *
     * @param {string} loginId 用户注册成功后返回的userid
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.trackSignUp = function (loginId) {
        if (!loginId) {
            throw new Error('please make sure the login id is correct!');
        }
        this.trackData.properties.anonymous_id = this.initUserId();
        this.trackData.properties.register_id = loginId;
        this._trackEvent('trackSignUp');
        delete this.trackData.properties['anonymous_id'];
        delete this.trackData.properties['register_id'];
    };
    /**
     * 用户登录 - 用于更新用户id
     *
     * @param {string}
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.login = function (loginId) {
        if (loginId) {
            this.trackData.is_login = true;
            this.trackData.user_id = String(loginId);
        }
        else {
            throw new Error('please make sure the login id is correct!');
        }
    };
    /**
     * 退出登录
     *
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.logout = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.trackData.is_login = false;
                this.trackData.user_id = '';
                this.trackData.properties = this.initProperties;
                return [2 /*return*/];
            });
        });
    };
    /**
     * 设置公共属性，设置后每次上报都会带有设置的属性
     *
     * @param {*} [params={}]
     * @memberof JueXiaoBrowserStatSDK
     */
    JueXiaoMiniStatSDK.prototype.setPublicProperties = function (params) {
        if (params === void 0) { params = {}; }
        this.initProperties = Object.assign({}, params, this.initProperties);
    };
    /**
     * 上传opendid
     *
     * 为了提高数据的准确性，小程序需要在运行时从服务端获取 openid 和 unionid
     *
     * 注意：openid一定能获取到，unionid在用户从未登录授权过公众号时无法获取到
     * @param {string} openid
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.setOpenid = function (openid) {
        // 传入openid 且 当前没有登录时才设置openid
        // 已登录用户无需再设置 openid
        if (openid && !this.trackData.is_login) {
            this.trackData.distinct_id = String(openid);
            // 把本地的uuid替换为openid
            wx.setStorageSync(types_1.Constants.JUEXIAO_STAT_UUID, openid);
        }
    };
    /**
     * 上传unionid
     *
     * 为了提高数据的准确性，小程序需要在运行时从服务端获取 openid 和 unionid
     *
     * 注意：openid一定能获取到，unionid在用户从未登录授权过公众号时无法获取到
     * @param {string} unionid
     * @memberof JueXiaoMiniStatSDK
     */
    JueXiaoMiniStatSDK.prototype.setUnionid = function (unionid) {
        if (unionid) {
            this.initProperties.unionid = unionid;
        }
    };
    return JueXiaoMiniStatSDK;
}());
exports.default = JueXiaoMiniStatSDK;
//# sourceMappingURL=miniprogram.js.map