"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sendData = exports.formatSystem = void 0;
var types_1 = require("../types");
var index_1 = require("./index");
/**
 * 格式化操作系统
 *
 * @export
 * @param {*} system
 * @returns
 */
function formatSystem(system) {
    var _system = system.toLowerCase();
    if (_system === 'ios') {
        return 'IOS';
    }
    else if (_system === 'android') {
        return 'Android';
    }
    else {
        return system;
    }
}
exports.formatSystem = formatSystem;
/**
 * 发送数据
 *
 * @export
 * @param {string} id
 * @param {string} url
 * @param {UserEvent} data
 */
function sendData(id, url, data, debug) {
    if (debug === void 0) { debug = false; }
    if (index_1.checkPropertyKey(data.properties)) {
        var URL_1 = url + "?data=" + encodeURIComponent(JSON.stringify(data)) + "&project_id=" + id + "&type=" + types_1.Constants.LIBRARY_JS;
        // 开启调试时传入
        if (debug) {
            URL_1 += '&debug=true';
        }
        // 根据环境不同使用 wx,my,qq
        if (wx) {
            wx.request({
                url: URL_1,
                method: 'GET'
            });
        }
    }
}
exports.sendData = sendData;
//# sourceMappingURL=mini.js.map