import { UserEvent } from '../types';
/**
 * 获取操作系统 和 浏览器 信息
 *
 * @export
 * @returns os 操作系统名字 ver 操作系统版本号
 */
export declare function getOsInfo(): {
    isMobile: RegExpMatchArray | null;
    os: string;
    osVersion: string;
    browser: string;
    browserVersion: string;
};
/**
 * 使用图片的请求方式
 *
 * @export
 * @param {string} id
 * @param {string} url
 * @param {UserEvent} data
 */
export declare function sendDataWithImg(id: string, url: string, data: UserEvent, debug?: boolean): void;
interface PositionInfo {
    longitude?: number;
    latitude?: number;
}
/**
 * 获取经纬度
 *
 * @export
 * @returns {Promise<PositionInfo>}
 */
export declare function getLocation(): Promise<PositionInfo>;
export {};
